FTAP_Display_MouseKeyEventsBox = {};

function FTAP_Display_MouseKeyEventsBox.onClick(args)
	if args == nil or type(args) ~= "table" or args.clickAreaTable == nil then return;end;
	if args.isDown then
		if g_currentMission.hlUtils.dragDrop.on then return;end;
		if args.button == Input.MOUSE_BUTTON_LEFT then
			local box = args.box;
			if box ~= nil then
				if args.clickAreaTable.whereClick == "settingInBox_" and args.clickAreaTable.areaClick == "settingIcon_" then
					if box.isSetting then 
						--box.menue[1].show = true;
						box.ownTable.lastStateExtraLine=box.viewExtraLine;
						box.viewExtraLine = true;
					else 
						--box.menue[1].show = false;
						box.viewExtraLine = box.ownTable.lastStateExtraLine;
					end;
				elseif args.clickAreaTable.whereClick == "settingInBox_" and args.clickAreaTable.areaClick == "menueClose_" then
					box.isSetting = false;box.viewExtraLine = box.ownTable.lastStateExtraLine;				
				elseif args.clickAreaTable.whereClick == "settingInBox_" and args.clickAreaTable.areaClick == "viewExtraLine_" then
					box.ownTable.lastStateExtraLine=box.viewExtraLine;
				end;
			end;
		end;
	end;
end;

function FTAP_Display_MouseKeyEventsBox.onClickArea(args)
	if args == nil or type(args) ~= "table" or args.clickAreaTable == nil then return;end;
		
	if args.isDown then
		if g_currentMission.hlUtils.dragDrop.on then return;end;
		if args.button == Input.MOUSE_BUTTON_LEFT then
			local box = args.box;
			if box ~= nil then
				if box.viewExtraLine then					
					if args.clickAreaTable.whereClick == "search_" then						
						g_currentMission.hlHudSystem:searchFilter(box, true, g_i18n:getText("searchFilter_Info1"));						
						return;
					elseif args.clickAreaTable.whereClick == "viewPrice_" then
						box.ownTable.viewPrice = not box.ownTable.viewPrice;
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;
					elseif args.clickAreaTable.whereClick == "viewPriceTrend_" then
						box.ownTable.viewPriceTrend = not box.ownTable.viewPriceTrend;
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;
					elseif args.clickAreaTable.whereClick == "viewFillAmounts_" then
						box.ownTable.viewFillAmounts = not box.ownTable.viewFillAmounts;
						box:setUpdateState(true);
						return;
					elseif args.clickAreaTable.whereClick == "viewEmptyAmounts_" then
						box.ownTable.viewEmptyAmounts = not box.ownTable.viewEmptyAmounts;
						box:setUpdateState(true);
						return;
					elseif args.clickAreaTable.whereClick == "viewProductions_" then 
						box.ownTable.viewProductions = not box.ownTable.viewProductions;
						FTAP_DisplaySetGet:setFillTypesAmount();
						FTAP_DisplaySetGet:setViewFillTypes(box);						
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;
					elseif args.clickAreaTable.whereClick == "viewAnimals_" then
						box.ownTable.viewAnimals = not box.ownTable.viewAnimals;
						if box.ownTable.viewAnimals then FTAP_DisplaySetGet:setNumOfAnimals();end; --update by player						
						FTAP_DisplaySetGet:setViewFillTypes(box);
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;
					elseif args.clickAreaTable.whereClick == "viewPal_" then
						box.ownTable.viewPal = not box.ownTable.viewPal;
						if box.ownTable.viewPal then FTAP_DisplaySetGet:setPalletsAmount();end; --update by player
						FTAP_DisplaySetGet:setViewFillTypes(box);
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;
					elseif args.clickAreaTable.whereClick == "viewBales_" then
						box.ownTable.viewBales = not box.ownTable.viewBales;
						if box.ownTable.viewBales then FTAP_DisplaySetGet:setBalesAmount();end; --update by player
						FTAP_DisplaySetGet:setViewFillTypes(box);
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;					
					elseif args.clickAreaTable.whereClick == "closeAllGroupLines_" then
						FTAP_DisplaySetGet:setClosedAllGroups();						
						return;
					elseif args.clickAreaTable.whereClick == "viewFillType_" then
						if box.ownTable.viewFillType+1 > box.ownTable.maxViewFillType then box.ownTable.viewFillType = 1;else box.ownTable.viewFillType = box.ownTable.viewFillType+1;end;
						--box:setUpdateState(false);
						g_currentMission.hlHudSystem.isSave = false; --global
						return;
					elseif args.clickAreaTable.whereClick == "sortBy_" then
						if box.ownTable.sortBy+1 > box.ownTable.maxSortBy then box.ownTable.sortBy = 1;else box.ownTable.sortBy = box.ownTable.sortBy+1;end;						
						box:setUpdateState(true);
						return;
					elseif args.clickAreaTable.whereClick == "settingLineDistance_" then
						local maxDistance = box.screen.pixelH*8;
						if box.screen.size.distance.textLine+(box.screen.pixelH/2) <= maxDistance then
							box.screen.size.distance.textLine = box.screen.size.distance.textLine+(box.screen.pixelH/2);
							box:setUpdateState(true);							
						end;
						return;
					end;					
				end;
				if args.clickAreaTable.whereClick == "viewAmountStorages_" then
					if args.clickAreaTable.ownTable[1] ~= nil then
						local fillType = FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]];
						if fillType ~= nil then
							if fillType.viewAmountStorages then 
								fillType.viewAmountStorages = false;							
							elseif fillType.amounts.storage ~= nil or (fillType.isAnimal and #fillType.animals > 0) or (box.ownTable.viewPal and fillType.pallets.fillLevel ~= nil) or (box.ownTable.viewBales and fillType.bales.fillLevel ~= nil) or (box.ownTable.viewTrees and fillType.trees.fillLevel ~= nil) then
								fillType.viewBestPriceStations = false;
								fillType.viewAmountStorages = true;
							end;
						end;					
					end;
				elseif args.clickAreaTable.whereClick == "viewBestPriceStations_" then 
					if args.clickAreaTable.ownTable[1] ~= nil then
						local fillType = FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]];
						if fillType ~= nil and fillType.bestPrices ~= nil then
							fillType.viewAmountStorages = false;
							fillType.viewBestPriceStations = not fillType.viewBestPriceStations;
						end;
					end;				
				elseif args.clickAreaTable.whereClick == "fillTypeMarkedDesiredSellPrice_" then 
					if args.clickAreaTable.ownTable[1] ~= nil then
						if FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]] ~= nil then
							--FTAP_DisplaySetGet:setDesiredSellPrice(box, args.clickAreaTable.ownTable[1])
						end;
					end;	
				end;							
			end;
		elseif args.button == Input.MOUSE_BUTTON_RIGHT then
			local box = args.box;
			if box ~= nil then
				if box.viewExtraLine then					
					if args.clickAreaTable.whereClick == "settingLineDistance_" then
						local minDistance = box.screen.pixelH*1;
						if box.screen.size.distance.textLine-(box.screen.pixelH/2) >= minDistance then
							box.screen.size.distance.textLine = box.screen.size.distance.textLine-(box.screen.pixelH/2);
							box:setUpdateState(true);							
						end;
						return;
					elseif args.clickAreaTable.whereClick == "viewPriceTrend_" then --not found prices ! bug !
						if box.ownTable.changeViewPrices[1] < 3 then box.ownTable.changeViewPrices[1] = box.ownTable.changeViewPrices[1]+1;FTAP_DisplaySetGet:setChangeFillTypesPrice();end;
						--FTAP_DisplaySetGet:searchBug(box.ownTable.changeViewPrices[1]);
					elseif args.clickAreaTable.whereClick == "viewFillType_" then
						box.ownTable.viewShowOnPriceTable = not box.ownTable.viewShowOnPriceTable;
						box:setUpdateState(true);
						return;
					elseif args.clickAreaTable.whereClick == "search_" then
						box.searchFilter = "";					
						return;
					end;					
				end;
				if args.clickAreaTable.whereClick == "viewBestPriceStations_" then					
					local hasPlayerFarmId = g_currentMission.hlUtils.hasPlayerFarmId();
					if hasPlayerFarmId then FTAP_DisplaySetGet:showInGameMenuFrame("ingameMenuGameStats", "SUB_CATEGORY.PRICES", FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]], false, 0, true);end;	
				elseif args.clickAreaTable.whereClick == "viewAnimals_" then
					if box.ownTable.viewTypAnimals == 2 then
						box.ownTable.viewTypAnimals = 1;
					else
						box.ownTable.viewTypAnimals = 2;
					end;
					box.isSave = false;
				elseif args.clickAreaTable.whereClick == "storageObject_" then --teleport
					local storage = args.clickAreaTable.ownTable[1];
					if storage ~= nil then
						g_currentMission.hlUtils.teleportPlayerToObject(storage);
					end;
				elseif args.clickAreaTable.whereClick == "bestPriceObject_" then --teleport
					local station = args.clickAreaTable.ownTable[1];
					if station ~= nil then
						g_currentMission.hlUtils.teleportPlayerToObject(station);
					end;	
				elseif args.clickAreaTable.whereClick == "animalObject_" then --teleport
					local animal = args.clickAreaTable.ownTable[1];
					if animal ~= nil then
						g_currentMission.hlUtils.teleportPlayerToObject(animal);
					end;
				elseif args.clickAreaTable.whereClick == "fillTypeMarkedDesiredSellPrice_" then 
					if args.clickAreaTable.ownTable[1] ~= nil then
						local fillType = FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]];
						if fillType ~= nil then
							fillType.isMarked = not fillType.isMarked;
							if fillType.isMarked then
								local map = g_currentMission.missionInfo.map;
								if box.ownTable.fillTypes.maps[map.id] == nil then box.ownTable.fillTypes.maps[map.id] = {marked={},desiredSellPrice={}};end;								
								box.ownTable.fillTypes.maps[map.id].marked[fillType.name] = true;								
								g_currentMission.hlHudSystem.showInfoBox( {string.format(g_i18n:getText("box_markedOnInfo"), tostring(fillType.title)), 2000, g_currentMission.hlUtils.getColor("ls25active", true)} );
							else
								local map = g_currentMission.missionInfo.map;
								if box.ownTable.fillTypes.maps[map.id] == nil or box.ownTable.fillTypes.maps[map.id].marked == nil then return;end;
								if box.ownTable.fillTypes.maps[map.id].marked[fillType.name] ~= nil then box.ownTable.fillTypes.maps[map.id].marked[fillType.name] = nil;end;
								g_currentMission.hlHudSystem.showInfoBox( {string.format(g_i18n:getText("box_markedOffInfo"), tostring(fillType.title)), 2000, g_currentMission.hlUtils.getColor("ls25active", true)} );								
							end;							
						end;
					end;	
				end;							
			end;
		elseif args.button == Input.MOUSE_BUTTON_MIDDLE then
			local box = args.box;
			if box ~= nil then				
				if args.clickAreaTable.whereClick == "balesObject_" then --map hotspot
					local fillType = FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]];
					if fillType ~= nil and fillType.bales.nodeId ~= nil then						
						g_currentMission.hlHudSystem.setMapHotspot(fillType.bales.nodeId);						
					end;
				elseif args.clickAreaTable.whereClick == "palletsObject_" then --map hotspot
					local fillType = FTAP_DisplaySetGet.fillTypes[args.clickAreaTable.ownTable[1]];
					if fillType ~= nil and fillType.pallets.nodeId ~= nil then						
						g_currentMission.hlHudSystem.setMapHotspot(fillType.pallets.nodeId);						
					end;										
				elseif args.clickAreaTable.whereClick == "storageObject_" then --map hotspot
					local storage = args.clickAreaTable.ownTable[1];
					if storage ~= nil then
						g_currentMission.hlHudSystem.setMapHotspot( {storage} );						
					end;
				elseif args.clickAreaTable.whereClick == "bestPriceObject_" then --map hotspot
					local station = args.clickAreaTable.ownTable[1];
					if station ~= nil then						
						g_currentMission.hlHudSystem.setMapHotspot( {station} );						
					end;	
				elseif args.clickAreaTable.whereClick == "animalObject_" then --map hotspot
					local animal = args.clickAreaTable.ownTable[1];
					if animal ~= nil then						
						g_currentMission.hlHudSystem.setMapHotspot( {animal} );						
					end;
				end;
			end;
		end;	
	end;
end;