FTAP_Display_MouseKeyEventsHud = {};

function FTAP_Display_MouseKeyEventsHud.onClick(args)
	if args == nil or type(args) ~= "table" or args.clickAreaTable == nil then return;end;
	if args.isDown then
		if g_currentMission.hlUtils.dragDrop.on then return;end;	
		local hud = args.hud;
		if hud ~= nil then
			if args.button == Input.MOUSE_BUTTON_LEFT then
				if args.clickAreaTable.whereClick == "ftapIcon_" then					
					if g_currentMission.hlHudSystem.hlBox ~= nil then
						local box = g_currentMission.hlHudSystem.hlBox:getData("FTAP_Display_Box"); --search Box
						if box == nil then --not found then generate Box
							FTAP_Display_XmlBox:loadBox("FTAP_Display_Box", false);
						else
							box.show = not box.show;
							if not box.show then box.isSetting = false;end;
						end;
					end;
				elseif hud.isSetting and args.clickAreaTable.whereClick == "hud_" then
					if hud.ownTable.viewHudTyp+1 > hud.ownTable.maxHudTyp then
						hud.ownTable.viewHudTyp = 1;
						hud.autoZoomOutIn = "text";
					else
						hud.ownTable.viewHudTyp = hud.ownTable.viewHudTyp+1;
						hud.autoZoomOutIn = "";
					end;
					g_currentMission.hlHudSystem.isSave = false;
					hud.isSave = false;
				end;
			end;
		end;
	end;
end;