FTAP_Display_XmlHud = {};

function FTAP_Display_XmlHud:defaultValues(hud)
	hud.ownTable = {viewHudTyp=2, maxHudTyp=3};
end;

function FTAP_Display_XmlHud:onLoadXml(hud, Xml, xmlNameTag)
	if hud.ownTable.viewHudTyp == nil then FTAP_Display_XmlHud:defaultValues(hud);end;	
	if Xml ~= nil and xmlNameTag ~= nil then	
		if getXMLInt(Xml, xmlNameTag.."#viewHudTyp") ~= nil then 
			hud.ownTable.viewHudTyp = getXMLInt(Xml, xmlNameTag.. "#viewHudTyp");
		else
			return; --first config not found
		end;
		
	end;	
end;

function FTAP_Display_XmlHud.onSaveXml(hud, Xml, xmlNameTag)	
	setXMLInt(Xml, xmlNameTag.."#version", FTAP_Display.metadata.xmlVersion);
	setXMLInt(Xml, xmlNameTag.."#viewHudTyp", hud.ownTable.viewHudTyp);	
end;